// CTapeCtrlView.cpp: файл реализации
//

#include "stdafx.h"
#include "resource.h"
#include "TapeCtrlView.h"
#include "BKErrMsgSys.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#define new DEBUG_NEW
#endif

// CTapeCtrlView

IMPLEMENT_DYNAMIC(CTapeCtrlView, CDockablePane)

CTapeCtrlView::CTapeCtrlView()
{
}

CTapeCtrlView::~CTapeCtrlView()
{
}

BEGIN_MESSAGE_MAP(CTapeCtrlView, CDockablePane)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_WM_PAINT()
END_MESSAGE_MAP()


// обработчики сообщений CTapeCtrlView

int CTapeCtrlView::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CDockablePane::OnCreate(lpCreateStruct) == -1)
	{
		return -1;
	}

	if (!m_TapeCtrlDlg.Create(IDD_TAPE_CONTROL, this))
	{
		CBKMessageBox(g_pstrErrors[BK_ERROR_NOCTAPECTRLDLGINIT]);
		TRACE0("Не удалось создать диалог Tape Control\n");
		return -1;      // не удалось создать
	}

	AdjustLayout();
	return 0;
}

void CTapeCtrlView::OnSize(UINT nType, int cx, int cy)
{
	AdjustLayout();
	CDockablePane::OnSize(nType, cx, cy);
}

void CTapeCtrlView::AdjustLayout()
{
	if (GetSafeHwnd() == nullptr)
	{
		return;
	}

	CDockablePane::AdjustLayout();
	CSize size(m_TapeCtrlDlg.GetMinSize());
	int c = (IsDocked()) ? GetSystemMetrics(SM_CYSMCAPTION) : 0;
	size.cy += c;
	SetMinSize(size);
	CRect rectClient;
	GetClientRect(rectClient);
	m_TapeCtrlDlg.SetWindowPos(nullptr, rectClient.left, rectClient.top, rectClient.Width(), rectClient.Height(), SWP_NOACTIVATE | SWP_NOZORDER);
}

void CTapeCtrlView::OnPaint()
{
	CPaintDC dc(this); // device context for painting

	// TODO: добавьте свой код обработчика сообщений
	// Не вызывать CDockablePane::OnPaint() для сообщений рисования
	if (IsVisible())
	{
		m_TapeCtrlDlg.RedrawWindow();
	}
}

void CTapeCtrlView::UpdateTapeControls(bool bEmuLoad, bool bEmuSave)
{
	m_TapeCtrlDlg.GetDlgItem(IDC_TC_RECORD)->EnableWindow(bEmuSave ? FALSE : TRUE);
	m_TapeCtrlDlg.GetDlgItem(IDC_TC_STOP)->EnableWindow((bEmuLoad && bEmuSave) ? FALSE : TRUE);
}

void CTapeCtrlView::InitParams(CString &strPath, CTape *pTape)
{
	m_TapeCtrlDlg.m_strTapePath = strPath;
	m_TapeCtrlDlg.SetTape(pTape);
	m_TapeCtrlDlg.InitParam();
	m_TapeCtrlDlg.UpdateData(FALSE);
}

